<?php

if ( ! defined( 'WPTYPEK_CACHE_SEPARATOR' ) ) {
	define( 'WPTYPEK_CACHE_SEPARATOR', '{-}' );
}

if ( strtoupper( $_SERVER['REQUEST_METHOD'] ) === 'GET' ) {
    $options = [
        'cache_enable'        => '--cache_enable--',
        'mobile_cache_enable' => '--mobile_cache_enable--',
        'page_cache_lifetime' => '--page_cache_lifetime--',
        'disable_logged_in_users' => '--disable_logged_in_users--',
        'disable_admin_users' => '--disable_admin_users--',
        'pro_http2_push_enable' => '--pro_http2_push_enable--',
    ];

    if ( $options['page_cache_lifetime'] == '0' ) {
        $options['page_cache_lifetime'] = '900';
    }

    if ( !is_admin() && $options['cache_enable'] > 0 ) {
        $user_logged_in = false;
        $user_is_admin = false;

        if (!empty($_COOKIE)) {
            $auth_cookie_key_regex = '/wordpress(_sec|user|pass|_logged_in)_/';

            foreach($_COOKIE as $key => $value) {
                if (preg_match($auth_cookie_key_regex, $key)) {
                    $user_logged_in = true;
                    if (strpos($value, 'admin')) {
                        $user_is_admin = true;
                    }
                }
            }
        }
        $disable_logged_in_users = (bool)$options['disable_logged_in_users'];
        $disable_admin_users = (bool)$options['disable_admin_users'];

        if (!$disable_logged_in_users || !$user_logged_in || ($user_is_admin && !$disable_admin_users)) {
            $is_mobile = function () use ( $options ) {
                $userAgent = $_SERVER['HTTP_USER_AGENT'];

                if ( $options['mobile_cache_enable'] > 0 && ! empty( $userAgent )
                     && (
                         strpos( $userAgent, 'Mobile' ) !== false
                         || strpos( $userAgent, 'Android' ) !== false
                         || strpos( $userAgent, 'iPhone' ) !== false
                         || strpos( $userAgent, 'iPod' ) !== false
                         || strpos( $userAgent, 'BlackBerry' ) !== false
                         || strpos( $userAgent, 'webOS' ) !== false
                         || strpos( $userAgent, 'Kindle' ) !== false
                         || strpos( $userAgent, 'Opera Mini' ) !== false
                         || strpos( $userAgent, 'Opera Mobi' ) !== false
                     )
                ) {
                    return true;
                } else {
                    return false;
                }
            };

            $mobile_prefix = $is_mobile() ? ( 'mobile' . DIRECTORY_SEPARATOR ) : '';

            $file            = $mobile_prefix . trim( str_replace( '/', WPTYPEK_CACHE_SEPARATOR, $_SERVER['REQUEST_URI'] ) . 'cache.html', '-' );
            $file_cache_path = __DIR__ . DIRECTORY_SEPARATOR . 'cache' . DIRECTORY_SEPARATOR . 'wp-typek' . DIRECTORY_SEPARATOR . 'page' . DIRECTORY_SEPARATOR . $file;
            if ( file_exists( $file_cache_path ) ) {
                $file_modified = @filemtime( $file_cache_path );
                if ( time() <= $file_modified + (int) $options['page_cache_lifetime'] ) {

                    if ($options['pro_http2_push_enable'] > 0) {
                        $header_file_path = str_replace( '.html', '.header', $file_cache_path );
                        if ( file_exists( $header_file_path ) ) {
                            $headers = file_get_contents( $header_file_path );
                            header( $headers );
                        }
                    }

                    readfile( $file_cache_path );
                    exit;
                }
            }
        }
    }
}
