/** ## <plugin_mod@mirek> ## */

function applyAutoSettings(int, pos) {
    var selectoron = getSelector(int, "on");
    var selectoroff = getSelector(int, "off");

    if (jQuery(selectoron).length) {
        jQuery(selectoron).val("1");
    }

    if (jQuery(selectoroff).length) {
        jQuery(selectoroff).val("0");
    }

    submitWPTypekSettings();
}


jQuery(document).ready(function () {
    jQuery('[data-exclude-wrapper="true"]').on('click', function () {
        var expand = jQuery(this.parentNode.parentNode).find('[data-exclude-expand="true"]');

        if (jQuery(this).find('input:checked').val() > 0) {
            expand.slideUp();
        } else {
            expand.slideDown();
        }
    });

    jQuery('.wptypek--radio-group').on('click', handleRadioGroup);

    jQuery('#wptypekMainContainer').find('form').on('submit', function (e) {
        setWptypekLoading();
    });

    jQuery('#wptypekMainContainer .wptypek--nav-item, #wptypekMainContainer .button-wptypek').on('click', function (e) {
        if (!e.target.onclick) {
            setWptypekLoading();
        }
    });
});

function handleRadioGroup() {
    var toggleSection;
    if (jQuery(this).attr('data-wptypek-toggling')) {
        toggleSection = jQuery('[data-wptypek-toggled="' + jQuery(this).attr('data-wptypek-toggling') + '"]');
    }

    if (jQuery(this).find('input:checked').val() > 0) {
        jQuery(this).find('input[value=0]').prop('checked', true);
        jQuery(this).find('input[value=1]').prop('checked', false);
        jQuery(this).removeClass('wptypek--radio-group__active');

        if (toggleSection && toggleSection.length > 0) {
            toggleSection.slideUp();
        }
    } else {
        jQuery(this).find('input[value=0]').prop('checked', false);
        jQuery(this).find('input[value=1]').prop('checked', true);
        jQuery(this).addClass('wptypek--radio-group__active');

        if (toggleSection && toggleSection.length > 0) {
            toggleSection.slideDown();
        }
    }

    const lazyLoadFieldName = jQuery(this).data('lazy-load-field-name');
    const lazyLoadRuleKey = jQuery(this).data('lazy-load-rule-key');
    if (lazyLoadFieldName && lazyLoadRuleKey) {
        handleJavascriptManagerLazyLoadFieldChange(lazyLoadFieldName, lazyLoadRuleKey);
    }

}

function setWptypekLoading() {
    jQuery('#wptypekMainContainer').find('form [name="Submit"]').attr('disabled', 'disabled');
    jQuery('#wptypekMainContainer').addClass('wptypek--loading');
}

function addWPTypekOption(id) {
    var input = jQuery("#" + id + " + .chzn-container > .chzn-choices > .search-field > input, #" + id + " + .chosen-container > .chosen-choices > .search-field > input");
    var txt = input.val();

    if (txt === input.prop("defaultValue")) {
        txt = null;
    }

    if (txt === null || txt === "") {
        alert("Please input an item in the box to add to the drop-down list");
        return false;
    }

    jQuery("#" + id).append(jQuery("<option/>", {
        value: txt.replace("...", ""),
        text: txt
    }).attr("selected", "selected"));

    jQuery("#" + id).trigger("liszt:updated");
    jQuery("#" + id).trigger("chosen:updated");
}

function ucFirst(string) {
    return string[0].toUpperCase() + string.slice(1);
}

function getTimeStamp() {
    return new Date().getTime();
}

function addExcludeUrlGroup(assetHash) {
    var excludeGroups = jQuery('.wptypek--input-item__row[data-asset="' + assetHash + '"]');
    var excludeGroupsAmount = excludeGroups.length;
    var newExcludeGroup = excludeGroups.last().clone();
    var replaceIndexRegex = new RegExp('(\\[' + (excludeGroupsAmount - 1) + '\\])', 'g');
    newExcludeGroup.html(
        newExcludeGroup.html()
            .replace(replaceIndexRegex, '[' + (excludeGroupsAmount) + ']')
            .replace('selected', '')
    );
    newExcludeGroup.find('input').val('');

    var excludeButtons = jQuery('.wptypek--exclude-url-buttons[data-asset="' + assetHash + '"]');
    jQuery(newExcludeGroup).insertBefore(excludeButtons);
    excludeButtons.find('.button[data-remove="true"]').attr('disabled', false);
}

function removeExcludeUrlGroup(assetHash) {
    var excludeGroups = jQuery('.wptypek--input-item__row[data-asset="' + assetHash + '"]');
    if (excludeGroups.length > 1) {
        excludeGroups.last().remove();
    }

    if (excludeGroups.length <= 2) {
        jQuery('.wptypek--exclude-url-buttons[data-asset="' + assetHash + '"] .button[data-remove="true"]').attr('disabled', 'disabled');
    }
}

function removeJavascriptAddRule(event, that) {
    event.preventDefault();
    event.stopPropagation();

    var $emptyRuleset = jQuery('#empty-ruleset');

    var newRuleset = $emptyRuleset.clone().attr('id', '').attr('style', '');

    newRuleset.html(
        newRuleset.html()
            .replace(/\+\+rule--key\+\+/g, (Date.now()))
            .replace(/_chzn-custom-value/g, 'chzn-custom-value')
    );
    newRuleset.insertBefore(that);

    if (!!jQuery.prototype.chosen) {
        jQuery("select.chzn-custom-value").chosen({width: "240px"});
    }

    jQuery('.wptypek--exclude-wrapper .wptypek--radio-group').off('click', handleRadioGroup);
    jQuery('.wptypek--exclude-wrapper .wptypek--radio-group').on('click', handleRadioGroup);
}

function removeJavascriptRemoveRule(event, that) {
    event.preventDefault();
    event.stopPropagation();

    jQuery(that).parent('.wptypek--exclude-wrapper').remove();
}

function handleJavascriptManagerLazyLoadFieldChange(fieldName, ruleKey) {
    var $inputField = jQuery('input[name="' + fieldName + '"]').filter(':checked');
    var $reverseLogicField = jQuery('[data-reverse-removal="' + ruleKey + '"]');

    if ($inputField.val() > 0) {
        $reverseLogicField.slideUp();
    } else {
        $reverseLogicField.slideDown();
    }
}

function confirmRedirect(url, message) {
    var ask = window.confirm(message);
    if (ask) {
        setWptypekLoading();
        window.location.href = url;
    }
}

