<?php

namespace WpTypek\Core;

use WpTypek\Platform\Plugin;

defined( '_WPTYPEK_EXEC' ) or die( 'Restricted access' );

/**
 * Class WPTypekJsLoadOnScroll
 * ## <plugin_mod@mirek> ##
 */
class WPTypekJsLoadOnScroll {
    public static function rewriteScriptTags( $html ) {
        try {
            require_once __DIR__ . '/libs/dom-parser.php';

            // Process only GET requests
            if ( $_SERVER['REQUEST_METHOD'] !== 'GET' ) {
                return $html;
            }

            // Detect non-HTML
            if ( ! isset( $html ) || trim( $html ) === '' || strcasecmp( substr( $html, 0, 5 ), '<?xml' ) === 0 || trim( $html )[0] !== "<" ) {
                return $html;
            }


            // Parse HTML
            $newHtml = str_get_html( $html );

            // Not HTML, return original
            if ( ! is_object( $newHtml ) ) {
                return $html;
            }

            $params = Plugin::getPluginParams();
            $excludeJs = $params->get('excludeJs');

            foreach ( $newHtml->find( "script[!type],script[type='text/javascript'],script[type='application/javascript']" ) as $script ) {

                if (!$script->getAttribute('data-skip-scroll-on-load')) {
                    $script->setAttribute( "data-type", "javascript/blocked" );
                    $script->removeAttribute('defer');
                    $script->removeAttribute('async');
                    $script->removeAttribute('type');
                    $src = $script->getAttribute( "src" );
                    if ( $src ) {
                        $canDeferScript = true;
                        if (!empty($excludeJs)) {
                            foreach ($excludeJs as $excludeJsItem) {
                                if (strpos($src, $excludeJsItem) !== false) {
                                    $canDeferScript = false;
                                    $script->removeAttribute( "data-type" );
                                    break;
                                }
                            }
                        }
                        if ($canDeferScript) {
                            $script->setAttribute( "data-src", $script->getAttribute( "src" ) );
                            $script->removeAttribute( "src" );
                        }
                    } else {
                        $script->setAttribute( "data-src", "data:text/javascript;base64," . base64_encode( $script->innertext ) );
                        $script->innertext = "";
                    }
                }
            }

            return $newHtml;
        } catch ( Exception $e ) {
            return $html;
        }
    }
}
